/*
 * LCDText_Defs.h
 *
 *  Created on: Jul 8, 2015
 *      Author: RK
 */

#ifndef LCDTEXT_DEFS_H_
#define LCDTEXT_DEFS_H_

#define BIT7 0x80
#define BIT6 0x40
#define BIT5 0x20
#define BIT4 0x10
#define BIT3 0x08
#define BIT2 0x04
#define BIT1 0x02
#define BIT0 0x01

#define HIGH 1
#define LOW 0

#define TRUE 1
#define FALSE 0

#define ROW 0
#define COL 1

#define CHAR_HEIGHT 10
#define CHAR_WIDTH 1

#define NUM_LINE_DATA_BYTES 16
#define NUM_LINES 60

#define IDLE 0
#define DATA_UPDATE_MODE_SENT 1
#define FIRST_LINE_ADDR_SENT 2
#define LINE_DATA_SENT 3
#define PRE_ADDR_DUMMY_SENT 4
#define NEW_ADDR_SENT 5
#define LAST_LINE_DATA_SENT 6
#define FIRST_POST_DATA_DUMMY_SENT 7
#define SECOND_POST_DATA_DUMMY_SENT 8
#define ALL_CLEAR_SENT 9
#define FIRST_ALLCLEAR_DUMMY_SENT 10
#define SECOND_ALLCLEAR_DUMMY_SENT 11

//global variables shared across files
extern bit UPDATE_LCD;
extern unsigned char Scroll_LineNum;
extern code unsigned char LCDLineAddr_LUT[];
extern unsigned char LCDTxState;
extern xdata unsigned char LCDDisplayData[NUM_LINES][NUM_LINE_DATA_BYTES];

//function prototypes
void UpdateAllLCDLines();
void LCDAllClear();
void InitLCD();
void InsertCharacter(unsigned char *);

//port pins
sbit RGBLED_G = P1^4;
sbit RGBLED_B = P1^5;
sbit RGBLED_R = P1^6;

sbit SPI_CS = P0^1;

//LCD Characters
extern code unsigned char LCD_A[CHAR_HEIGHT];
extern code unsigned char LCD_B[CHAR_HEIGHT];
extern code unsigned char LCD_C[CHAR_HEIGHT];
extern code unsigned char LCD_D[CHAR_HEIGHT];
extern code unsigned char LCD_E[CHAR_HEIGHT];
extern code unsigned char LCD_F[CHAR_HEIGHT];
extern code unsigned char LCD_G[CHAR_HEIGHT];
extern code unsigned char LCD_H[CHAR_HEIGHT];
extern code unsigned char LCD_I[CHAR_HEIGHT];
extern code unsigned char LCD_J[CHAR_HEIGHT];
extern code unsigned char LCD_K[CHAR_HEIGHT];
extern code unsigned char LCD_L[CHAR_HEIGHT];
extern code unsigned char LCD_M[CHAR_HEIGHT];
extern code unsigned char LCD_N[CHAR_HEIGHT];
extern code unsigned char LCD_O[CHAR_HEIGHT];
extern code unsigned char LCD_P[CHAR_HEIGHT];
extern code unsigned char LCD_Q[CHAR_HEIGHT];
extern code unsigned char LCD_R[CHAR_HEIGHT];
extern code unsigned char LCD_S[CHAR_HEIGHT];
extern code unsigned char LCD_T[CHAR_HEIGHT];
extern code unsigned char LCD_U[CHAR_HEIGHT];
extern code unsigned char LCD_V[CHAR_HEIGHT];
extern code unsigned char LCD_W[CHAR_HEIGHT];
extern code unsigned char LCD_X[CHAR_HEIGHT];
extern code unsigned char LCD_Y[CHAR_HEIGHT];
extern code unsigned char LCD_Z[CHAR_HEIGHT];


#endif /* LCDTEXT_DEFS_H_ */
