while 1
    ImageFilename = uigetfile(["*.bmp"]);
    
    if(length(ImageFilename) == 0)
        break
    end
    
    CurrentImage = ReadImage(ImageFilename);
    
    CurrentImage = SegmentByThreshold(CurrentImage, 100);
    
    CurrentImage = flipdim(CurrentImage, 2);
    
    PixelData = uint8(zeros(10,1));
    
    for row = 1:10
        for column = 1:8
            if (CurrentImage(row,column) == %T)
               PixelData(row) = bitset(PixelData(row), column, 1);
            else
                PixelData(row) = bitset(PixelData(row), column, 0);
            end
        end
    end
    
    [path, fname, extension] = fileparts(ImageFilename);
      
    printf('code unsigned char %s[CHAR_HEIGHT] = {', fname)
    for row = 1:10
        printf('0x%02X',  PixelData(row))
        if(row ~= 10)
            printf(', ')
        else
            printf('};\n\n')
        end
    end
    
end

printf('\n\n-------------------Extern declarations------------------\n\n')

while 1
    ImageFilename = uigetfile(["*.bmp"]);
    
    if(length(ImageFilename) == 0)
        break
    end
    
    CurrentImage = ReadImage(ImageFilename);
    
    [path, fname, extension] = fileparts(ImageFilename);
    
    printf('extern code unsigned char %s[CHAR_HEIGHT];\n', fname)
    
end



